#!/bin/bash

REPOSITORY="${HOME}/apt-wget/scripts/install"
if [ ! -f "${REPOSITORY}/wget-debs-syn.sh" ] || [ ! -f "${REPOSITORY}/debs-syn.txt" ]
then
    echo "NAO FOI GERADO O ARQUIVO DE SCRIPT \"${REPOSITORY}/wget-debs-syn.sh\" PELO SYNAPTIC"
    echo "E/OU NAO FOI SALVO AS MARCACOES DOS PACOTES EM \"${REPOSITORY}/debs-syn.txt\", FEITAS NO SYNAPTIC"
    echo "OU VOCE SALVOU O SCRIPT/MARCACOES COM NOME(S) DIFERENTE(S) DO ESPERADO"
    echo -n "DIGITE ENTER PARA TERMINAR ..."
    read
    exit -1
fi

echo "#!/bin/bash" > "${REPOSITORY}/move-debs.sh"
echo "sudo mv -f *.deb /var/cache/apt/archives/" >> "${REPOSITORY}/move-debs.sh"
echo "sudo chmod -x /var/cache/apt/archives/*.deb" >> "${REPOSITORY}/move-debs.sh"
echo "sudo chown root.root /var/cache/apt/archives/*.deb" >> "${REPOSITORY}/move-debs.sh"
echo "echo -n \"DIGITE ENTER PARA TERMINAR ...\"" >> "${REPOSITORY}/move-debs.sh"
echo "read" >> "${REPOSITORY}/move-debs.sh"
chmod 0755 "${REPOSITORY}/move-debs.sh"

sudo chown joaomanoel\: -R "${HOME}/apt-wget/"
${HOME}/apt-wget/bin/sh2bat.sh ${REPOSITORY}/wget-debs-syn.sh
[ ! -f "${REPOSITORY}/.syn-count" ] && echo "0" > "${REPOSITORY}/.syn-count"
syn_count="`cat "${REPOSITORY}/.syn-count"`"
mv -f ${REPOSITORY}/wget-debs-syn.sh  ${REPOSITORY}/wget-debs-syn-${syn_count}.sh
mv -f ${REPOSITORY}/wget-debs-syn.bat ${REPOSITORY}/wget-debs-syn-${syn_count}.bat
mv -f ${REPOSITORY}/debs-syn.txt ${REPOSITORY}/debs-syn-${syn_count}.txt
let syn_count++
echo "${syn_count}" > "${REPOSITORY}/.syn-count"

cp -f "${HOME}/apt-wget/bin/wget.exe.orig"      "${REPOSITORY}/wget.exe"
cp -f "${HOME}/apt-wget/bin/libeay32.dll.orig"  "${REPOSITORY}/libeay32.dll"
cp -f "${HOME}/apt-wget/bin/libiconv2.dll.orig" "${REPOSITORY}/libiconv2.dll"
cp -f "${HOME}/apt-wget/bin/libintl3.dll.orig"  "${REPOSITORY}/libintl3.dll"
cp -f "${HOME}/apt-wget/bin/libssl32.dll.orig"  "${REPOSITORY}/libssl32.dll"
chmod 0755 "${REPOSITORY}/wget.exe" \
           "${REPOSITORY}/libeay32.dll" \
           "${REPOSITORY}/libiconv2.dll" \
           "${REPOSITORY}/libintl3.dll" \
           "${REPOSITORY}/libssl32.dll"

echo -n "DIGITE ENTER PARA TERMINAR ..."
read
