#!/bin/bash

op="$1"
shift 1

case "$op" in
    "update")
	    REPOSITORY="${HOME}/apt-wget/scripts/update"
    	mkdir -p "${REPOSITORY}"
    	[ ! -f "${REPOSITORY}/.count" ] && echo "0" > "${REPOSITORY}/.count"
    	count="`cat "${REPOSITORY}/.count"`"
    	echo "#!/bin/bash" > "${REPOSITORY}/apt-get-update.sh"
    	echo "sudo apt-get update" >> "${REPOSITORY}/apt-get-update.sh"
    	echo "echo -n \"DIGITE ENTER PARA TERMINAR ...\"" >> "${REPOSITORY}/apt-get-update.sh"
    	echo "read" >> "${REPOSITORY}/apt-get-update.sh"
    	chmod 0755 "${REPOSITORY}/apt-get-update.sh"
    	echo "#!/bin/bash" > "${REPOSITORY}/wget-lists-${count}.sh"
    	echo "#!/bin/bash" > "${REPOSITORY}/move-lists-${count}.sh"
    	echo "echo off" > "${REPOSITORY}/wget-lists-${count}.bat"
    	IFS=$'\n'
    	for i in `apt-get update -y --print-uris | grep -e "http" -e "ftp" | awk -F \' '{print $2}'`
	    do
	        awk -f "${HOME}/apt-wget/bin/apt-wget-update.awk" --unix "${i}" \
	            >> "${REPOSITORY}/wget-lists-${count}.sh"
    	    awk -f "${HOME}/apt-wget/bin/apt-wget-update.awk" --dos  "${i}" \
    	        >> "${REPOSITORY}/wget-lists-${count}.bat"
    	    awk -f "${HOME}/apt-wget/bin/apt-wget-update.awk" --move "${i}" \
    	        >> "${REPOSITORY}/move-lists-${count}.sh"
    	    awk -f "${HOME}/apt-wget/bin/apt-wget-update.awk" --chmod "${i}" \
    	        >> "${REPOSITORY}/move-lists-${count}.sh"
            if [ "`basename "${i}" ".bz2"`" != "`basename "${i}"`" ]
            then
    	        awk -f "${HOME}/apt-wget/bin/apt-wget-update.awk" --bunzip2 "${i}" \
    	            >> "${REPOSITORY}/move-lists-${count}.sh"
    	    fi
	    done
    	echo "sudo chown root.root -R /var/lib/apt/lists/" >> "${REPOSITORY}/move-lists-${count}.sh"
    	echo "echo -n \"DIGITE ENTER PARA TERMINAR ...\"" >> "${REPOSITORY}/move-lists-${count}.sh"
    	echo "read" >> "${REPOSITORY}/move-lists-${count}.sh"
    	flip -m -b "${REPOSITORY}/wget-lists-${count}.bat"
    	chmod 0755 "${REPOSITORY}/wget-lists-${count}.bat" "${REPOSITORY}/wget-lists-${count}.sh" \
    	           "${REPOSITORY}/move-lists-${count}.sh"
	    let count++
	    echo "${count}" > "${REPOSITORY}/.count"
	    ;;	
    "install")
    	REPOSITORY="${HOME}/apt-wget/scripts/install"
    	mkdir -p "${REPOSITORY}"
    	echo "#!/bin/bash" > "${REPOSITORY}/move-debs.sh"
    	echo "sudo mv -f *.deb /var/cache/apt/archives/" >> "${REPOSITORY}/move-debs.sh"
    	echo "sudo chmod -x /var/cache/apt/archives/*.deb" >> "${REPOSITORY}/move-debs.sh"
    	echo "sudo chown root.root /var/cache/apt/archives/*.deb" >> "${REPOSITORY}/move-debs.sh"
    	echo "echo -n \"DIGITE ENTER PARA TERMINAR ...\"" >> "${REPOSITORY}/move-debs.sh"
    	echo "read" >> "${REPOSITORY}/move-debs.sh"
    	chmod 0755 "${REPOSITORY}/move-debs.sh"
    	[ ! -f "${REPOSITORY}/.count" ] && echo "0" > "${REPOSITORY}/.count"
    	count="`cat "${REPOSITORY}/.count"`"
    	echo "#!/bin/bash" > "${REPOSITORY}/wget-debs-${count}.sh"
    	apt-get install -y --print-uris $@ | grep "deb" | grep -e "http" -e "ftp" | \
    	    awk -F \' '{print "wget -c " $2}' >> "${REPOSITORY}/wget-debs-${count}.sh"
    	echo "echo off" > "${REPOSITORY}/wget-debs-${count}.bat"
    	apt-get install -y --print-uris $@ | grep "deb" | grep -e "http" -e "ftp" | \
    	    awk -F \' '{print "wget.exe -c " $2}' >> "${REPOSITORY}/wget-debs-${count}.bat"
    	echo "#!/bin/bash" > "${REPOSITORY}/apt-get-install-${count}.sh"
    	echo -n -e "sudo apt-get install -y \\" >> "${REPOSITORY}/apt-get-install-${count}.sh"
    	echo -n -e "\n\t" >> "${REPOSITORY}/apt-get-install-${count}.sh"
    	let c=1
    	IFS=" "$'\t'$'\n'
    	for i in $@
    	do
    	    if ((c<5))
    	    then
        		echo -n "${i} " >> "${REPOSITORY}/apt-get-install-${count}.sh"
	        	let c++
		        continue
	        fi
	        echo -n -e "${i} \\" >> "${REPOSITORY}/apt-get-install-${count}.sh"
    	    echo -n -e "\n\t" >> "${REPOSITORY}/apt-get-install-${count}.sh"
    	    let c=1
    	done
    	echo "bash" >> "${REPOSITORY}/apt-get-install-${count}.sh"
    	echo "echo -n \"DIGITE ENTER PARA TERMINAR ...\"" >> "${REPOSITORY}/apt-get-install-${count}.sh"
    	echo "read" >> "${REPOSITORY}/apt-get-install-${count}.sh"
    	flip -m -b "${REPOSITORY}/wget-debs-${count}.bat"
    	chmod 0755 "${REPOSITORY}/wget-debs-${count}.bat" "${REPOSITORY}/wget-debs-${count}.sh" \
    	           "${REPOSITORY}/apt-get-install-${count}.sh"
    	let count++
    	echo "${count}" > "${REPOSITORY}/.count"
    	;;
    "upgrade"|"dist-upgrade")
    	REPOSITORY="${HOME}/apt-wget/scripts/${op}"
    	mkdir -p "${REPOSITORY}"
        echo "#!/bin/bash" > "${REPOSITORY}/move-debs.sh"
    	echo "sudo mv -f *.deb /var/cache/apt/archives/" >> "${REPOSITORY}/move-debs.sh"
    	echo "sudo chmod -x /var/cache/apt/archives/*.deb" >> "${REPOSITORY}/move-debs.sh"
    	echo "sudo chown root.root /var/cache/apt/archives/*.deb" >> "${REPOSITORY}/move-debs.sh"
    	echo "echo -n \"DIGITE ENTER PARA TERMINAR ...\"" >> "${REPOSITORY}/move-debs.sh"
    	echo "read" >> "${REPOSITORY}/move-debs.sh"
    	echo "#!/bin/bash" > "${REPOSITORY}/apt-get-${op}.sh"
    	echo "sudo apt-get ${op} -y" >> "${REPOSITORY}/apt-get-${op}.sh"
    	echo "echo -n \"DIGITE ENTER PARA TERMINAR ...\"" >> "${REPOSITORY}/apt-get-${op}.sh"
    	echo "read" >> "${REPOSITORY}/apt-get-${op}.sh"
    	chmod 0755 "${REPOSITORY}/apt-get-${op}.sh" "${REPOSITORY}/move-debs.sh"
    	[ ! -f "${REPOSITORY}/.count" ] && echo "0" > "${REPOSITORY}/.count"
    	count="`cat "${REPOSITORY}/.count"`"
    	echo "#!/bin/bash" > "${REPOSITORY}/wget-debs-${count}.sh"
    	apt-get ${op} -y --print-uris | grep "deb" | grep -e "http" -e "ftp" | \
    	    awk -F \' '{print "wget -c " $2}' >> "${REPOSITORY}/wget-debs-${count}.sh"
    	echo "echo off" > "${REPOSITORY}/wget-debs-${count}.bat"
    	apt-get ${op} -y --print-uris | grep "deb" | grep -e "http" -e "ftp" | \
    	    awk -F \' '{print "wget.exe -c " $2}' >> "${REPOSITORY}/wget-debs-${count}.bat"
    	flip -m -b "${REPOSITORY}/wget-debs-${count}.bat"
    	chmod 0755 "${REPOSITORY}/wget-debs-${count}.bat" "${REPOSITORY}/wget-debs-${count}.sh"
    	let count++
    	echo "${count}" > "${REPOSITORY}/.count"
    	;;
    *)
    	echo -n -e "\n\aUso:\n\t"
    	echo -n -e "$0  install  pacote-1.deb pacote-2.deb ...\n\t"
	    echo -n -e "$0  update|upgrade|dist-upgrade\n\n"
	    exit 0
	    ;;
esac

cp -f "${HOME}/apt-wget/bin/wget.exe.orig"      "${REPOSITORY}/wget.exe"
cp -f "${HOME}/apt-wget/bin/libeay32.dll.orig"  "${REPOSITORY}/libeay32.dll"
cp -f "${HOME}/apt-wget/bin/libiconv2.dll.orig" "${REPOSITORY}/libiconv2.dll"
cp -f "${HOME}/apt-wget/bin/libintl3.dll.orig"  "${REPOSITORY}/libintl3.dll"
cp -f "${HOME}/apt-wget/bin/libssl32.dll.orig"  "${REPOSITORY}/libssl32.dll"
chmod 0755 "${REPOSITORY}/wget.exe" \
           "${REPOSITORY}/libeay32.dll" \
           "${REPOSITORY}/libiconv2.dll" \
           "${REPOSITORY}/libintl3.dll" \
           "${REPOSITORY}/libssl32.dll"
